ad_page_contract {
    Administration page for intranet-search-oracle
    
    @author Marc Baiges Camprub (tm08707@salleurl.edu)
} {

}

# ---------------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------------

set user_id [ad_maybe_redirect_for_registration]
set return_url [im_url_with_query]
set current_url [ns_conn url]



# ---------------------------------------------------------------------
# List themes in im_ef_themes
# ---------------------------------------------------------------------
proc theme_lista { } {
        set html "
                <table>
                <tr><td>
                        <ul>
        "
        # Go through all themes in the database
        set sql "select theme_name,theme_id from im_ef_themes order by theme_name"
	db_foreach get_themes $sql {
                append html "
                        <li> $theme_name <a href='ef_theme_edit?theme_id=$theme_id'>(Edit theme)</a>
                "
	}
        append html "
        </ul>
        <br>
        <a href='ef_theme_add.tcl'>Add new theme</a>
        </td></tr>
        </table>
"

    return $html
}

# ---------------------------------------------------------------------
# List projects not used for trainning yet
# ---------------------------------------------------------------------
proc proj_list { current_url} {
        set html "
                <table>
                <tr><td>
                        <ul>
        "
        # Go through all projects not used yet
        set sql "select project_id,project_name from im_projects order by project_name"
	db_foreach get_proj $sql {
                append html "
                        <li> $project_name <a href='ef_train_project.tcl?project_id=$project_id'>(Train project)</a>
                "
	}
        append html "
        </ul>
        </td></tr>
        </table>
"

    return $html
}


# ---------------------------------------------------------------------
# Performs the action of editing an existing theme
# ---------------------------------------------------------------------
proc theme_edit_action { current_url parent_id theme_name theme_id} {
	return "$parent_id - $theme_name"
}



# ---------------------------------------------------------------------
# Component creation proc. Shows a different state depending on the 
# current action 
# ---------------------------------------------------------------------
ad_proc -public im_ef_theme_manager_component { action theme_id theme_name parent_id} {

} {
        set current_url [ns_conn url]

        if { [string equal $action "list"] } {
           set html [theme_list]
        } elseif { [string equal $action "add"] } {
           set html [theme_add_form $current_url]
        } elseif { [string equal $action "add-2"] } {
           set html [theme_add_action $current_url $parent_id $theme_name]
        } elseif { [string equal $action "edit"] } {
           set html [theme_edit_form $current_url $theme_id]
       	} elseif { [string equal $action "edit-2"] } {
           set html [theme_edit_action $current_url $parent_id $theme_id $theme_name]
	}
        return [im_table_with_title "EF Theme Manager" $html]    

}


ad_proc -public im_ef_data_source_manager_component { action project_id} {

} {
        set current_url [ns_conn url]

        if { [string equal $action "list"] } {
           set html [proj_list $current_url]
        } elseif { [string equal $action "train"] } {
           set html [proj_train_list $current_url $project_id]
        }
    return [im_table_with_title "EF Data Source" $html]
}



proc get_themes_component { } {
   return [im_ef_theme_manager_component "list" "none" "none" "none"]   
}

proc get_data_source_component { } {
    return [im_ef_data_source_manager_component "list" "none"]
}

