ad_page_contract {
    Administration page for intranet-search-oracle

    @param project_id   The project to be trained
    @author Marc Baiges Camprub (tm08707@salleurl.edu)
} {    
    project_id
}

# Proc to read a file's content
proc read_file { name } {
    set f [open $name]
         set data ""
    set data [read $f]
         close $f
         return $data
}


# create a list with affinity values to each theme
set theme_values [list]
lappend theme_values {2 0.0}
lappend theme_values {3 1.0}
lappend theme_values {4 0.0}
lappend theme_values {5 0.0}
lappend theme_values {6 0.2}
lappend theme_values {8 0.0}

set contingut ""

# Add all values to get the total amount of affinity
set total_values 0.0
foreach puntuacio $theme_values {
	set total_values [expr $total_values + [lindex $puntuacio 1]]	
}

# Normalize each value of affinity respect the total
set theme_norm_values [list]
foreach puntuacio $theme_values {
	
	set tmp_list [list]
	lappend tmp_list [lindex $puntuacio 0]
	lappend tmp_list [expr [lindex $puntuacio 1] / $total_values]
	
	lappend theme_norm_values $tmp_list
}


proc assign_probs_projects {} {
	# Assign the normalized affinity values to the project in the database
	foreach tema $theme_norm_values {
		db_transaction {
			set t_p_a [lindex $tema 1]
			set t_id [lindex $tema 0]
			db_dml theme_add {
				insert into im_ef_projects(project_id,theme_id,theme_prob_assigned,theme_prob_calc)
				values(:project_id,:t_id,:t_p_a,0)		
			}
		} on_error {
			ad_return_error "Error adding probabilites for the project's themes" "Problems adding probabilites to 
			the theme [lindex $tema 0] of the project $project_id <br>
			Here the error message: <pre>$errmsg\n</pre>\n"
			return
		}
		
	}
}

#[assign_probs_projects]

# Expand these values to the project's documents
set files [im_filestorage_find_files $project_id]
foreach the_file $files {
	# Look for the file owner (first line in the file)
	set file_data [read_file $the_file]
	set lines [split $file_data "\n"]
	set user_email [lindex $lines 0]
	append contingut "usuari $user_email <BR>"	
		
	db_1row get_user_id "select user_id from users where username=:user_email"
	
	#set user_id 31326
	
	db_transaction {	
		db_dml doc_add {
			insert into im_ef_documents(doc_id,owner,path)
			values(im_ef_doc_id_seq.nextval,:user_id,:the_file)		
		}
	} on_error {
		ad_return_error "Error expanding probabilites to project's documents" "Problems adding probabilites to 
		the document at $file <br>
		Here the error message: <pre>$errmsg\n</pre>\n"
		return	
	}
}

append contingut $theme_norm_values

db_release_unused_handles 

doc_return  200 text/html $contingut